package com.fs.watch.mapper;

import com.fs.his.domain.FsHealthTongue;
import com.fs.watch.domain.WatchFsUser;
import com.fs.watch.domain.WatchUser;
import com.fs.watch.domain.vo.WatchUserAndHealthVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 用户腕表配置表(WatchUser)表数据库访问层
 *
 * @author makejava
 * @since 2024-10-17 17:11:11
 */
public interface WatchUserMapper {


    /**
     * 通过userId查询
     * @param userId
     * @return
     */
    WatchUser selectWatchUserById(Long userId);

    /**
     * 通过userId查询用户及腕表数据
     *
     * @param userId 主键
     * @return 实例对象
     */
    WatchFsUser selectWatchFsUserById(Long userId);

    /**
     * 通过deviceId查询用户及腕表数据
     * @param deviceId
     * @return
     */
    WatchFsUser selectWatchFsUserByDeviceIdAndUserId(@Param("deviceId") String deviceId,@Param("userId") Long userId,@Param("type") Integer type);

    /**
     * 查询指定行数据
     *
     * @param watchUser 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<WatchUser> queryAllByLimit(WatchUser watchUser, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param watchUser 查询条件
     * @return 总行数
     */
    long count(WatchUser watchUser);

    /**
     * 新增数据
     *
     * @param watchUser 实例对象
     * @return 影响行数
     */
    int insert(WatchUser watchUser);

    int updateWatchUser(WatchUser watchUser);


    /**
     * 通过主键删除数据
     *
     * @param userId 主键
     * @return 影响行数
     */
    int deleteById(Long userId);


    int updateFsUserByDeviceId(WatchFsUser user);

    List<WatchUserAndHealthVo> listByDeviceIdNotNull();

    FsHealthTongue getLastTongueByDeviceId(@Param("deviceId") String deviceId);

    List<WatchFsUser> selectWatchFsUserByDeviceId(@Param("deviceId")String deviceId);
}

